public class ChampernowneConstant implements IRealNumber
{
  // This class represents the constant
  // 0.12345678910111213141516171819202122...
  // This number is trancedental and is therefore not
  // a zero of any polynomial with integer coefficients.
  // In particular, we cannot write it as any fraction.
  
  // Note that this function may return more digits than needed.
  public FractionalNumber approximate(int digits)
  {
    int digitsSoFar = 0;
    int digitsPerStep = 1;
    int number = 0;
    int power = 10;
    NaturalNumber numerator = new NaturalNumber(0);
    NaturalNumber denominator = new NaturalNumber(1);
    while (digitsSoFar < digits)
    {
      number++;
      if (number == power)
      {
        power *= 10;
        digitsPerStep++;
      }
      digitsSoFar += digitsPerStep;
      numerator = numerator.multiply(power).add(number);
      denominator = denominator.multiply(power);
    }
    return new FractionalNumber(numerator, denominator);
  }
}