import java.util.ArrayList;
public class EConstant implements IRealNumber
{
  // This class represents the constant E.
  // This number is trancedental and is therefore not
  // a zero of any polynomial with integer coefficients.
  // In particular, we cannot write it as any fraction.
  public FractionalNumber approximate(int digits)
  {
    NaturalNumber left = new NaturalNumber(4).multiply(new NaturalNumber(10).pow(digits));
    int k = 1;
    while (!NaturalNumber.factorial(k).isLargerThan(left))
    {
      k++;
    }
    k--;
    FractionalNumber result = new FractionalNumber(1);
    for (int i = 1; i <= k; i++)
    {
      result = result.add(new FractionalNumber(new NaturalNumber(1), NaturalNumber.factorial(i)));
    }
    return result;
  }
}